#include "seif.h"
#include <algorithm>
#include <vector>
using namespace std;

vector<int> lck, prv, nxt;

void Add(int F, int S) {
    if (lck.size() == 0) {
        lck.push_back(0);
        prv.push_back(0);
        nxt.push_back(0);
    }

    int D = F + S;
    lck.push_back(D);
    nxt.push_back(nxt.size());

    if (D == 9) {
        int not9 = prv.back();
        prv.push_back(not9);
        nxt[not9] = nxt.size() - 1;
    } else {
        int not9 = prv.back();
        nxt[not9] = prv.size() - 1;
        prv.push_back(prv.size());
    }
}

void Del(int k) {
    while (k --> 0) {
        lck.pop_back();
        prv.pop_back();
        nxt.pop_back();
    }
}

int Get(int p) {
    p = lck.size() - p;
    int nx = nxt[prv[p]];
    return (lck[p] + (nx + 1 < lck.size() ? lck[nx + 1] / 10 : 0)) % 10;
}
